(function($){
    'use strict';
    $(document).ready(function(){

        // ===============================================================
        // ========================= Prefixes ============================
        // ===============================================================

        var $ays_prefix   = 'ays_';
        var $name_prefix  = 'ays_arp_';
        var $id_prefix    = '#ays-arp-';
        var $class_prefix = '.ays-arp-';

        // ===============================================================
        // ========================= Prefixes ============================
        // ===============================================================
        var typOfArp = $(document).find($class_prefix +'arp-type').val();
        var defaultColors;
        if(typOfArp == 'under_posts'){
            defaultColors = {
                elegant: {
                    textColor: "#333",
                    bgColor: "rgba(255,255,255,0)",
                    bgHoverColor: "rgba(255,255,255,0)",
                    borderRadius: "0",
                },
                classy: {
                    textColor: "#333",
                    bgColor: "rgba(255,255,255,0)",
                    bgHoverColor: "rgba(255,255,255,0)",
                    borderRadius: "5",
                },
                grid: {
                    textColor: "#333",
                    bgColor: "rgba(255,255,255,0)",
                    bgHoverColor: "rgba(255,255,255,0)",
                    borderRadius: "0",
                }
            };
        }else if (typOfArp == 'widget') {
            defaultColors = {
                elegant: {
                    textColor: "#333",
                    bgColor: "#ffffff",
                    bgHoverColor: "#ffffff",
                    borderRadius: "0",
                },
                classy: {
                    textColor: "#333",
                    bgColor: "rgba(255,255,255,0)",
                    bgHoverColor: "rgba(51,51,51,0.9)",
                    borderRadius: "50",
                },
                grid: {
                    textColor: "#333",
                    bgColor: "rgba(255,255,255,0)",
                    bgHoverColor: "rgba(255,255,255,0)",
                    borderRadius: "0",
                }
            }; 
        }else{
            defaultColors = {
                elegant: {
                    textColor: "#333",
                    bgColor: "rgba(255,255,255,0)",
                    bgHoverColor: "rgba(255,255,255,0)",
                    borderRadius: "0",
                },
                classy: {
                    textColor: "#333",
                    bgColor: "rgba(255,255,255,0)",
                    bgHoverColor: "rgba(255,255,255,0)",
                    borderRadius: "0",
                },
                grid: {
                    textColor: "#333",
                    bgColor: "rgba(255,255,255,0)",
                    bgHoverColor: "rgba(255,255,255,0)",
                    borderRadius: "0",
                }
            };
        }

        
        
        var RelatedPostsLayout = $(document).find( $class_prefix + 'layout-radio:checked' ).val();
        RelatedPostsLayoutSetup( RelatedPostsLayout );

        function RelatedPostsLayoutSetup( layout ){
            var defaultTextColor;
            var defaultBgColor;
            var defaultBgHoverColor;
            var defaultBorderRadius;

            switch ( layout ) {
                case 'elegant':
                    defaultTextColor      = defaultColors.elegant.textColor;
                    defaultBgColor        = defaultColors.elegant.bgColor;
                    defaultBgHoverColor   = defaultColors.elegant.bgHoverColor;
                    defaultBorderRadius   = defaultColors.elegant.borderRadius;
                    break;
                case 'classy':
                    defaultTextColor      = defaultColors.classy.textColor;
                    defaultBgColor        = defaultColors.classy.bgColor;
                    defaultBgHoverColor   = defaultColors.classy.bgHoverColor;
                    defaultBorderRadius   = defaultColors.classy.borderRadius;
                    break;
                case 'grid':
                    defaultTextColor      = defaultColors.grid.textColor;
                    defaultBgColor        = defaultColors.grid.bgColor;
                    defaultBgHoverColor   = defaultColors.grid.bgHoverColor;
                    defaultBorderRadius   = defaultColors.grid.borderRadius;
                    break;
                default:
                    defaultTextColor      = defaultColors.elegant.textColor;
                    defaultBgColor        = defaultColors.elegant.bgColor;
                    defaultBgHoverColor   = defaultColors.elegant.bgHoverColor;
                    defaultBorderRadius   = defaultColors.elegant.borderRadius;
                    break;
            }

            var ays_arp_text_color_picker = {
                defaultColor: defaultTextColor,
                change: function (e) {
                }
            };
            var ays_arp_bg_color_picker = {
                defaultColor: defaultBgColor,
                change: function (e) {
                }
            };
            var ays_arp_bg_hover_color_picker = {
                defaultColor: defaultBgHoverColor,
                change: function (e) {
                }
            };            
            var ays_arp_border_color_picker = {
                change: function (e) {
                }
            };

            // Initialize color pickers
            $(document).find( $class_prefix + 'text-color').wpColorPicker(ays_arp_text_color_picker);
            $(document).find( $class_prefix + 'background-color').wpColorPicker(ays_arp_bg_color_picker);
            $(document).find( $class_prefix + 'background-color-hover').wpColorPicker(ays_arp_bg_hover_color_picker);
            $(document).find( $class_prefix + 'border-color').wpColorPicker(ays_arp_border_color_picker);
        }
        
        $(document).find( $class_prefix + 'layout-radio' ).on('change', function() {

            var RelatedPostsLayout = $(this).val();
            RelatedPostsLayoutChange( RelatedPostsLayout );
        } );

        function RelatedPostsLayoutChange( layout ){
            var defaultTextColor;
            var defaultBgColor;
            var defaultBgHoverColor;
            var defaultBorderRadius;

            switch ( layout ) {
                case 'elegant':
                    defaultTextColor = defaultColors.elegant.textColor;
                    defaultBgColor = defaultColors.elegant.bgColor;
                    defaultBgHoverColor = defaultColors.elegant.bgHoverColor;
                    defaultBorderRadius = defaultColors.elegant.borderRadius;
                    break;
                case 'classy':
                    defaultTextColor = defaultColors.classy.textColor;
                    defaultBgColor = defaultColors.classy.bgColor;
                    defaultBgHoverColor = defaultColors.classy.bgHoverColor;
                    defaultBorderRadius = defaultColors.classy.borderRadius;
                    break;
                case 'grid':
                    defaultTextColor = defaultColors.grid.textColor;
                    defaultBgColor = defaultColors.grid.bgColor;
                    defaultBgHoverColor = defaultColors.grid.bgHoverColor;
                    defaultBorderRadius = defaultColors.grid.borderRadius;
                    break;
                default:
                    defaultTextColor = defaultColors.elegant.textColor;
                    defaultBgColor = defaultColors.elegant.bgColor;
                    defaultBgHoverColor = defaultColors.elegant.bgHoverColor;
                    defaultBorderRadius = defaultColors.elegant.borderRadius;
                    break;
            }

            // Initialize color pickers
            $(document).find( $class_prefix + 'text-color').wpColorPicker('color', defaultTextColor);
            $(document).find( $class_prefix + 'background-color').wpColorPicker('color', defaultBgColor);
            $(document).find( $class_prefix + 'background-color-hover').wpColorPicker('color', defaultBgHoverColor);

            $(document).find( $class_prefix + 'border-radius').val(defaultBorderRadius);

            var thumbnailRatio = $(document).find( $class_prefix + 'thumbnail-ratio' );
            var readonlyAttr = thumbnailRatio.attr('readonly');

            if ( layout == 'grid' ) {
                thumbnailRatio.val(1);
                thumbnailRatio.prop( "readonly", true );
            } else {
                if (typeof readonlyAttr !== 'undefined' && readonlyAttr !== false) {
                    thumbnailRatio.removeAttr("readonly");
                }
            }
        }
    });
})(jQuery);
